<?xml version="1.0" encoding="US-ASCII"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

<!--
     Creates an XPath instance report from an arbitrary XML instance.

     $Id: Crane-xml2xpath-instance.xsl,v 1.1 2006/12/04 15:04:37 G. Ken Holman Exp $

Copyright (C) - Crane Softwrights Ltd. 
              - http://www.CraneSoftwrights.com/links/res-dev.htm

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, 
  this list of conditions and the following disclaimer. 
- Redistributions in binary form must reproduce the above copyright notice, 
  this list of conditions and the following disclaimer in the documentation 
  and/or other materials provided with the distribution. 
- The name of the author may not be used to endorse or promote products 
  derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN 
NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR 
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Note: for your reference, the above is the "Modified BSD license", this text
      was obtained 2002-12-16 at http://www.xfree86.org/3.3.6/COPYRIGHT2.html#5
-->

<xsl:output method="xml"/>

<xsl:template match="*">
  <!--determine location-->
  <xsl:variable name="ordinal">
    <xsl:number count="*" level="any"/>
  </xsl:variable>
  <!--reconstitute element-->
  <xsl:element name="{name(.)}" namespace="{namespace-uri(.)}">
    <xsl:copy-of select="namespace::*"/>
    <!--reconstitute attributes-->
    <xsl:for-each select="@*">
      <xsl:sort select="name(.)"/>
      <xsl:attribute name="{name(.)}" namespace="{namespace-uri(.)}">
        <xsl:value-of select="concat('!',$ordinal,'.',position(),'!')"/>
      </xsl:attribute>
    </xsl:for-each>
    <xsl:choose>
      <xsl:when test="not(*)">
        <!--only leaves have text-->
        <xsl:text/>!<xsl:value-of select="$ordinal"/>!<xsl:text/>
      </xsl:when>
      <xsl:otherwise>
        <!--branches need indentation to be copied-->
        <xsl:apply-templates select="*|text()"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:element>
</xsl:template>

</xsl:stylesheet>